*$ CREATE USIMBS.FOR
*COPY USIMBS
*
*=== Usimbs ===========================================================*
*
      SUBROUTINE USIMBS ( MREG, NEWREG, FIMP )

      INCLUDE '(DBLPRC)'
      INCLUDE '(DIMPAR)'
      INCLUDE '(IOUNIT)'
*
*----------------------------------------------------------------------*
*                                                                      *
*     Copyright (C) 2001-2005      by    Alfredo Ferrari & Paola Sala  *
*     All Rights Reserved.                                             *
*                                                                      *
*                                                                      *
*     USer defined IMportance BiaSing:                                 *
*                                                                      *
*     Created on   02 july 2001    by    Alfredo Ferrari & Paola Sala  *
*                                                   Infn - Milan       *
*                                                                      *
*     Last change on 09-jul-01     by    Alfredo Ferrari               *
*                                                                      *
*     Input variables:                                                 *
*                Mreg = region at the beginning of the step            *
*              Newreg = region at the end of the step                  *
*     (thru common TRACKR):                                            *
*              Jtrack = particle id. (Paprop numbering)                *
*              Etrack = particle total energy (GeV)                    *
*       X,Y,Ztrack(0) = position at the beginning of the step          *
*  X,Y,Ztrack(Ntrack) = position at the end of the step                *
*                                                                      *
*    Output variable:                                                  *
*                Fimp = importance ratio (new position/original one)   *
*                                                                      *
*----------------------------------------------------------------------*
*
      INCLUDE '(TRACKR)'
*
      IF (ZTRACK(NTRACK) .GT. 35) THEN
          REND = SQRT(XTRACK(NTRACK)**2 + YTRACK(NTRACK)**2 +
     & (ZTRACK(NTRACK) - 35)**2)
      END IF
*
      IF ((ZTRACK(NTRACK) .LE. 35) .AND. (ZTRACK(NTRACK) .GE. -35))
     & THEN
          REND = SQRT(XTRACK(NTRACK)**2 + YTRACK(NTRACK)**2)
      END IF
*
      IF (ZTRACK(NTRACK) .LT. -35) THEN
          REND = SQRT(XTRACK(NTRACK)**2 + YTRACK(NTRACK)**2 +
     & (ZTRACK(NTRACK) + 35)**2)
      END IF
*    
      REND = REND - 5
      IF (REND .LT. 0) THEN
          REND = 0
      ELSE IF (REND .GT. 10) THEN
          REND = 10
      END IF
*
      IF (ZTRACK(0) .GT. 35) THEN
          RSTART = SQRT(XTRACK(0)**2 + YTRACK(0)**2 + 
     &    (ZTRACK(0) - 35)**2)
      END IF
*
      IF ((ZTRACK(0) .LE. 35) .AND. (ZTRACK(0) .GE. -35)) THEN
          RSTART = SQRT(XTRACK(0)**2 + YTRACK(0)**2)
      END IF
*
      IF (ZTRACK(0) .LT. -35) THEN
          RSTART = SQRT(XTRACK(0)**2 + YTRACK(0)**2 +
     &    (ZTRACK(0) + 35)**2)
      END IF
* 
      RSTART = RSTART - 5
      IF (RSTART .LT. 0) THEN
          RSTART = 0
      ELSE IF (RSTART .GT. 10) THEN
          RSTART = 10
      END IF
*
      IF ((REND - RSTART) .GT. 0.1) THEN
           FIMP = 2
      ELSE
           FIMP = 1
      END IF
*
      RETURN
*=== End of subroutine Usimbs =========================================*
      END

